// Class Code 18B
// Demo 1 Fast
// This runs about 60 frames per second ( on Jim's computer)
// because the background pattern is rendered one time as a 
// PGraphics object named pg.  This is rendered and saved (similar
// to calling saveFrame( ) by setup and it is stored in memory for
// the duration of the execution of the program.

// Then, the first line of draw( ) is a call to the image( ) function
// that has as the first argument, the PGraphics object.

// This means that Processing does not have to compute the location of the
// hundreds of ellipses that make up the image.  This allows the code to
// run much faster.

// For what you may find interesting, replace the imagae call with background( )
// using the PGraphics object as an argument.  Does this afffect the speed
// of execution?  It does on Jim's machine.


PGraphics pg;

void setup() 
{
  size(900, 900);
  rectMode( CENTER );
  ellipseMode( CENTER );
  smooth( );
  textSize( 24 );
  textAlign( CENTER, CENTER );
  
  pg = createGraphics(width, height, P2D);

  makeBackground( );
}

// This function makes what is essentially an image
// and stores it for quick retrieval when we want to
// display it.
void makeBackground( )
{
  pg.beginDraw( );
       pg.background( 0, 200, 0 );
       pg.stroke( 0 );
       pg.noFill( );
       for ( int x = 0; x < width; x += 10 )
       {
         pg.line( x, 0, width-x, height);
       } 
     
       for( int r = 0; r < width; r+=5)
       {
         for( int c = 0; c < height; c += 5)
         {
            pg.ellipse( r, c, 4, 4 );
         }
       } 
  pg.endDraw( );
}

void draw() 
{
     image( pg, 0, 0 );
      
       // draw moving figures
     noStroke( );
     fill( 255,  0, 0 );
     ellipse( width/2, frameCount%height, 20, 30 );
     ellipse( width/2, height - frameCount%height, 20, 30 );
     ellipse( frameCount%width, height/2, 40, 30 );
     ellipse( width - frameCount%width, height/2, 40, 30 );
     
     // show frame rate
     fill( 255 );
     rect( width/4, height*.105, 40, 24 );
     fill( 0, 0, 255 );
     text( int( frameRate), width/4, height*.10 );
}
